import sys, os
sys.path.insert(0, '/u/t/iorich-dev/talk-stuff/django/')
os.environ["DJANGO_SETTINGS_MODULE"] = "mysite.settings"
from django.conf import settings
from django.core.servers.basehttp import AdminMediaHandler
from django.core.handlers.wsgi import WSGIHandler
from pysqlite2 import dbapi2 as sqlite

import twill
from twill.commands import *

### module-level setup

def setup(module):
    module.app = AdminMediaHandler(WSGIHandler()) # set up Django app
        
    twill.add_wsgi_intercept('localhost', 80, lambda : module.app)
        
    module.url = 'http://localhost/'

def teardown(module):                   # clean up Django app
    del module.app
    twill.remove_wsgi_intercept('localhost', 80)

class TestDjangoPollSite:
    def setup(self):                    # trash database counts
        db = "/Users/t/iorich-dev/talk-stuff/django/mysite/db.sqlite"
        conn = sqlite.connect(db)
        cursor = conn.cursor()

        cursor.execute("update polls_choice set votes=0")
        conn.commit()
        
    def test(self):                     # this actually works.
        go(url + 'polls')
        follow('1')
        showforms()
        print '****** setting choice to "pycon"'
        fv('1', 'choice', 'pycon')
        showforms()
        submit()
        show()
        find("pycon -- 1 vote")
